<script src="@#file#(bresenham.js)" type="text/javascript"></script>

<p>Neka je linija zadana početnom točkom \(T_0=(x_0,y_0)\) i završnom točkom \(T_1=(x_1,y_1)\). Kroz ove dvije točke znamo napisati jednadžbu pravca:
\[
 y - y_0 = \frac{y_1-y_0}{x_1-x_0}(x-x_0)
\]
Izraz možemo preurediti tako da dobijemo sljedeći oblik:
\[
 y = a \cdot x + b
\]
tako da najprije član \(-y_0\) prebacimo na desnu stranu i potom se riješimo zagrade. Dobit ćemo:
\[
 y = \frac{y_1-y_0}{x_1-x_0} \cdot x - \frac{y_1-y_0}{x_1-x_0} \cdot x_0 + y_0
\]
iz čega slijedi:
\[
 a = \frac{y_1-y_0}{x_1-x_0}
\]
\[
 b =  - \frac{y_1-y_0}{x_1-x_0} \cdot x_0 + y_0
\]
Prisjetimo se: član \(a\) predstavlja koeficijent smjera pravca na kojem leži linija, odnosno odgovara tangensu kuta koji pravac zatvara s osi x. Član \(b\) odgovara sjecištu pravca i osi y.</p>

<p>Oslanjajući se na dobiveni izraz, napišimo naš prvi algoritam. Kako se pravac proteže od \(x=x_0\) do \(x=x_1\), izračunat ćemo koeficijente \(a\) i \(b\) te potom u petlji proći kroz sve x-eve od \(x_0\) do \(x_1\), za svaki ćemo \(x\) prema izrazu odrediti pripadni \(y\) i upaliti pripadni slikovni element s koordinatama (x,y). Kako pri tome možemo dobivati realne vrijednosti za y, odabrat ćemo onu vrijednost koja se dobije zaokruživanjem.</p>

<p>Kao radni primjer uzet ćemo prikaz linije od (1,1) do (17,8). Pseudokod opisanog algoritma prikazan je u nastavku.</p>

<pre>
void drawLine(int xs, int ys, int xe, int ye) {
  double a = (ye−ys)/(double)(xe−xs);
  double b = -a∗xs + ys ;

  for(int x=xs; x&lt;=xe; x++) {
    int y = zaokruzi(a∗x+b);
    osvijetli_pixel(x,y);
  }
}
</pre>

<p>Interaktivna demonstracija u nastavku ilustrira rad algoritma. Pritiskom na gumb "Korak" obrađuje se jedna po jedna x-vrijednost. Pritiskom na gumb "Reset" postupak se vraća na početak. Demonstracija omogućava i uključivanje prikaza "idealne" linije.</p>

  <div width="500" height="500" style="position:relative;">
  <canvas id="myCanvas1" width="500" height="500" style="border: 1px solid white;"></canvas>
  </div>
  <script type="text/javascript">
    var lineData1 = {x0: 1, y0: 1, x1: 17, y1: 8};
    var brcanvas1 = new RasterDisplay("myCanvas1", 20, 20);
    var alg1 = new BresenhamAlgorithm1(lineData1, brcanvas1);
    brcanvas1.idealLineData = lineData1;
    brcanvas1.paint();
  </script>
  <button onclick="alg1.reset(); document.getElementById('alg1btn').disabled=false;">Reset</button>
  <button id="alg1btn" onclick="alg1.next(); if(!alg1.hasNext()) this.disabled=true;">Korak</button>
  <input id="alg1ch1" type="checkbox" onclick="brcanvas1.showIdealLine = document.getElementById('alg1ch1').checked ? true : false; brcanvas1.paint();"> Prikaz idealne linije

<p>Uključite prikaz idealne linije i primijetite: za svaku x-vrijednost iz intervala 1 do 17, odabran je slikovni element čiji centar od idealne linije nije udaljeniji za više od 0.5 (dakle, najbliži mogući).</p>





